/*
NAME: 
DESCRIPTION: ;
PARAMETER:
    [
		{
            name : 'auto_save',
			title : '自动保存',
            type : 'RadioBox',
            property : {
				item_list:[
					{name:'yes',text:'YES'},
					{name:'no',text:'NO'},
				],
				tool_tip:'是否自动保存料号开关'
			}
        }
	]
	
 VERSION_HISTORY:
	V1.00 2020-04-15 Scott Sun
	    1.新版本
		
 HELP:
 	<html><body bgcolor="#DDECFE">
		<font size="3" color="#003DB2"><p>功能简介</p></font>
		<p> 数据标准化 </p>
		<br>
		<font size="3" color="#003DB2"><p>参数配置</p></font>
		<p> 客户配置 </p>
		<br>
		<font size="3" color="#003DB2"><p>注意事项</p></font>
		<p> 无 </p>
		<br>
	</body></html>	
*/
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// 引入模块 包
var $ = require('topcam.scriptfunc').argv();
var fs = require('fs');
var _ = require('lodash');
var database = require("topsin.database");
database.addConnection($.conf.database_conf, "DFM");
var QDfm = database.query("DFM");
if ($.conf.product_type == "aimdfm") {
	QDfm.updateRow({
		table: "pdm_aimdfm_task",
		data: {
			current_process_title: $.process_title
		},
		where: { id: $.task_id }
	});
}
var GEN = $.gen;
var fs = require("fs");
var Job = $.job_name;
var db = $.db
var Status = 'ok';
var resultData = [];
var PAR = {};
if ($.hasOwnProperty('script_parameter')){
	PAR = JSON.parse($.script_parameter);
}
if (!$.hasOwnProperty('auto_save')){
	PAR.auto_save = "no"
}

try {
    var par = PAR;

    // 检查原稿文件信息

    // 检查料号
    var job = Job.toLowerCase()
    if(!GEN.isJobExists({job:job})){throw "料号已经存在"}

    // 读入gerber或者odb++ 判断读入方式
    var inputInfo = inputInfo()
    // 读入odb++
    if(/odb/ig.test(inputInfo.type)){
        importJob({db:"genesis",path:inputInfo.data.path,name:job})
    }
    // 读入gerber
    if(/gerber/ig.test(inputInfo.type)){
        importGerber({})
    }
    // 保存 

    if(/yes/.test(par.auto_save)){
        GEN.checkInout({job:job,mode:"out"})  // 结束保存料号 关闭料号
        GEN.saveJob({ job: job });
        GEN.checkInout({job:job,mode:"in"})
        GEN.closeJob({job:job})
    }


    QDfm.updateRow({
		table: "pdm_aimdfm_task",
		data: {
			progress: 33.33
		},
		where: { id: $.task_id }
	});
	if (GEN.hasError()) {
		Status = 'error';
		resultData.push({ type: "error", title: "GEN错误!", detail: [{ desc: _.join(GEN.STATUS, "\n") }] });
		return {
			status: Status,
			result_data: resultData
		};
	} else {
		resultData.push({ type: "info", title: "操作完成, 请注意检查!" });
		return {
			status: Status,
			result_data: resultData
		};
	}
} catch (e) {
    Status = 'error';
    resultData.push({type: "error", title: "脚本执行出错!", detail: [{desc: _.toString(e)}]});
    return {status: Status, result_data: resultData};
}

function importJob(props){
    GEN.importJob(props);
}

function importGerber(props){  // job   db  step
    var job = props.job
    GEN.createJob({name:job,db:props.db})
    GEN.createStep({job:job,name:props.step})
    var gerberInfo = props.data.map(function(item){
        var gerberCfg = JSON.parse(JSON.stringify(item.format));
        var file = item.file
        gerberCfg.layer = file.name.toLowerCase()
        gerberCfg.path = file.path
        gerberCfg.format = item.type
        gerberCfg.job = job
        gerberCfg.step = step
        return gerberCfg
    })
    GEN.COM("input_manual_reset")
    gerberInfo.forEach(function(v){
        GEN.COM("input_manual_set",v)
    })
    GEN.COM("input_manual")
}